/*
 * Oceanengine Open Api
 * 巨量引擎开放平台 Open Api
 *
 * The version of the OpenAPI document: 1.1.19
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.bytedance.ads.api;

import com.bytedance.ads.ApiCallback;
import com.bytedance.ads.ApiClient;
import com.bytedance.ads.ApiException;
import com.bytedance.ads.ApiResponse;
import com.bytedance.ads.Configuration;
import com.bytedance.ads.Pair;

import com.google.gson.reflect.TypeToken;



import com.bytedance.ads.model.PromotionListV30Filtering;
import com.bytedance.ads.model.PromotionListV30IncludingMaterialAtrributes;
import com.bytedance.ads.model.PromotionListV30Response;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class PromotionListV30Api {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public PromotionListV30Api() {
        this(Configuration.getDefaultApiClient());
    }

    public PromotionListV30Api(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for openApiV30PromotionListGet
     * @param advertiserId  (required)
     * @param filtering  (optional)
     * @param fields  (optional)
     * @param includingMaterialAtrributes RETURN_CARRY_DATA 返回视频素材的搬运属性 (optional)
     * @param page  (optional, default to 1)
     * @param pageSize  (optional, default to 10)
     * @param cursor 页码游标值，第一次拉取，无需入参 同时传入时，cursor优先级大于page 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param count 页面数据量 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApiV30PromotionListGetCall(Long advertiserId, PromotionListV30Filtering filtering, List<String> fields, PromotionListV30IncludingMaterialAtrributes includingMaterialAtrributes, Long page, Long pageSize, Long cursor, Long count, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/open_api/v3.0/promotion/list/";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (advertiserId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("advertiser_id", advertiserId));
        }

        if (filtering != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("filtering", filtering));
        }

        if (fields != null) {
            localVarCollectionQueryParams.addAll(localVarApiClient.parameterToPairs("csv", "fields", fields));
        }

        if (includingMaterialAtrributes != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("including_material_atrributes", includingMaterialAtrributes));
        }

        if (page != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("page", page));
        }

        if (pageSize != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("page_size", pageSize));
        }

        if (cursor != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("cursor", cursor));
        }

        if (count != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("count", count));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "ApiKeyAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call openApiV30PromotionListGetValidateBeforeCall(Long advertiserId, PromotionListV30Filtering filtering, List<String> fields, PromotionListV30IncludingMaterialAtrributes includingMaterialAtrributes, Long page, Long pageSize, Long cursor, Long count, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'advertiserId' is set
        if (advertiserId == null) {
            throw new ApiException("Missing the required parameter 'advertiserId' when calling openApiV30PromotionListGet(Async)");
        }

        return openApiV30PromotionListGetCall(advertiserId, filtering, fields, includingMaterialAtrributes, page, pageSize, cursor, count, _callback);

    }

    /**
     * 
     * 
     * @param advertiserId  (required)
     * @param filtering  (optional)
     * @param fields  (optional)
     * @param includingMaterialAtrributes RETURN_CARRY_DATA 返回视频素材的搬运属性 (optional)
     * @param page  (optional, default to 1)
     * @param pageSize  (optional, default to 10)
     * @param cursor 页码游标值，第一次拉取，无需入参 同时传入时，cursor优先级大于page 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param count 页面数据量 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @return PromotionListV30Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public PromotionListV30Response openApiV30PromotionListGet(Long advertiserId, PromotionListV30Filtering filtering, List<String> fields, PromotionListV30IncludingMaterialAtrributes includingMaterialAtrributes, Long page, Long pageSize, Long cursor, Long count) throws ApiException {
        ApiResponse<PromotionListV30Response> localVarResp = openApiV30PromotionListGetWithHttpInfo(advertiserId, filtering, fields, includingMaterialAtrributes, page, pageSize, cursor, count);
        return localVarResp.getData();
    }

    /**
     * 
     * 
     * @param advertiserId  (required)
     * @param filtering  (optional)
     * @param fields  (optional)
     * @param includingMaterialAtrributes RETURN_CARRY_DATA 返回视频素材的搬运属性 (optional)
     * @param page  (optional, default to 1)
     * @param pageSize  (optional, default to 10)
     * @param cursor 页码游标值，第一次拉取，无需入参 同时传入时，cursor优先级大于page 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param count 页面数据量 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @return ApiResponse&lt;PromotionListV30Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<PromotionListV30Response> openApiV30PromotionListGetWithHttpInfo(Long advertiserId, PromotionListV30Filtering filtering, List<String> fields, PromotionListV30IncludingMaterialAtrributes includingMaterialAtrributes, Long page, Long pageSize, Long cursor, Long count) throws ApiException {
        okhttp3.Call localVarCall = openApiV30PromotionListGetValidateBeforeCall(advertiserId, filtering, fields, includingMaterialAtrributes, page, pageSize, cursor, count, null);
        Type localVarReturnType = new TypeToken<PromotionListV30Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     *  (asynchronously)
     * 
     * @param advertiserId  (required)
     * @param filtering  (optional)
     * @param fields  (optional)
     * @param includingMaterialAtrributes RETURN_CARRY_DATA 返回视频素材的搬运属性 (optional)
     * @param page  (optional, default to 1)
     * @param pageSize  (optional, default to 10)
     * @param cursor 页码游标值，第一次拉取，无需入参 同时传入时，cursor优先级大于page 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param count 页面数据量 注：page+page_size与cursor+count为两种分页方式 cursor+count适用于获取数据记录数≥10000的场景 (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApiV30PromotionListGetAsync(Long advertiserId, PromotionListV30Filtering filtering, List<String> fields, PromotionListV30IncludingMaterialAtrributes includingMaterialAtrributes, Long page, Long pageSize, Long cursor, Long count, final ApiCallback<PromotionListV30Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = openApiV30PromotionListGetValidateBeforeCall(advertiserId, filtering, fields, includingMaterialAtrributes, page, pageSize, cursor, count, _callback);
        Type localVarReturnType = new TypeToken<PromotionListV30Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
