/*
 * Oceanengine Open Api
 * 巨量引擎开放平台 Open Api
 *
 * The version of the OpenAPI document: 1.1.19
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.bytedance.ads.api;

import com.bytedance.ads.ApiCallback;
import com.bytedance.ads.ApiClient;
import com.bytedance.ads.ApiException;
import com.bytedance.ads.ApiResponse;
import com.bytedance.ads.Configuration;
import com.bytedance.ads.Pair;

import com.google.gson.reflect.TypeToken;



import com.bytedance.ads.model.StarComponentQueryIndustryAnchorV2Response;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class StarComponentQueryIndustryAnchorV2Api {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public StarComponentQueryIndustryAnchorV2Api() {
        this(Configuration.getDefaultApiClient());
    }

    public StarComponentQueryIndustryAnchorV2Api(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for openApi2StarComponentQueryIndustryAnchorGet
     * @param starId 星图客户ID (required)
     * @param anchorStatus 组件状态 0 &#x3D; 待送审 1 &#x3D; 有效 2 &#x3D;审核中 3 &#x3D; 审核失败 不传则为全部 (optional)
     * @param anchorType 行业锚点类型       电商 &#x3D; 1    汽车 &#x3D; 2    网服 &#x3D; 3    保险 &#x3D; 4    教育 &#x3D; 5    家装 &#x3D; 6    剪映锚点 &#x3D; 7    招商加盟组件 &#x3D; 8    旅游 &#x3D; 9    游戏行业组件 &#x3D; 10    通信行业组件 &#x3D; 11    房产行业组件 &#x3D; 12    西瓜行业组件 &#x3D; 13    轻颜行业组件 &#x3D; 14    醒图行业组件  &#x3D; 15 不传则为全部 (optional)
     * @param page 分页页码 正整数，默认1 (optional, default to 1)
     * @param limit 页大小 正整数且≤50，默认10 (optional, default to 10)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApi2StarComponentQueryIndustryAnchorGetCall(Long starId, Integer anchorStatus, Integer anchorType, Integer page, Integer limit, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/open_api/2/star/component/query_industry_anchor/";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (starId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("star_id", starId));
        }

        if (anchorStatus != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("anchor_status", anchorStatus));
        }

        if (anchorType != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("anchor_type", anchorType));
        }

        if (page != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("page", page));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "ApiKeyAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call openApi2StarComponentQueryIndustryAnchorGetValidateBeforeCall(Long starId, Integer anchorStatus, Integer anchorType, Integer page, Integer limit, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'starId' is set
        if (starId == null) {
            throw new ApiException("Missing the required parameter 'starId' when calling openApi2StarComponentQueryIndustryAnchorGet(Async)");
        }

        return openApi2StarComponentQueryIndustryAnchorGetCall(starId, anchorStatus, anchorType, page, limit, _callback);

    }

    /**
     * 
     * 
     * @param starId 星图客户ID (required)
     * @param anchorStatus 组件状态 0 &#x3D; 待送审 1 &#x3D; 有效 2 &#x3D;审核中 3 &#x3D; 审核失败 不传则为全部 (optional)
     * @param anchorType 行业锚点类型       电商 &#x3D; 1    汽车 &#x3D; 2    网服 &#x3D; 3    保险 &#x3D; 4    教育 &#x3D; 5    家装 &#x3D; 6    剪映锚点 &#x3D; 7    招商加盟组件 &#x3D; 8    旅游 &#x3D; 9    游戏行业组件 &#x3D; 10    通信行业组件 &#x3D; 11    房产行业组件 &#x3D; 12    西瓜行业组件 &#x3D; 13    轻颜行业组件 &#x3D; 14    醒图行业组件  &#x3D; 15 不传则为全部 (optional)
     * @param page 分页页码 正整数，默认1 (optional, default to 1)
     * @param limit 页大小 正整数且≤50，默认10 (optional, default to 10)
     * @return StarComponentQueryIndustryAnchorV2Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public StarComponentQueryIndustryAnchorV2Response openApi2StarComponentQueryIndustryAnchorGet(Long starId, Integer anchorStatus, Integer anchorType, Integer page, Integer limit) throws ApiException {
        ApiResponse<StarComponentQueryIndustryAnchorV2Response> localVarResp = openApi2StarComponentQueryIndustryAnchorGetWithHttpInfo(starId, anchorStatus, anchorType, page, limit);
        return localVarResp.getData();
    }

    /**
     * 
     * 
     * @param starId 星图客户ID (required)
     * @param anchorStatus 组件状态 0 &#x3D; 待送审 1 &#x3D; 有效 2 &#x3D;审核中 3 &#x3D; 审核失败 不传则为全部 (optional)
     * @param anchorType 行业锚点类型       电商 &#x3D; 1    汽车 &#x3D; 2    网服 &#x3D; 3    保险 &#x3D; 4    教育 &#x3D; 5    家装 &#x3D; 6    剪映锚点 &#x3D; 7    招商加盟组件 &#x3D; 8    旅游 &#x3D; 9    游戏行业组件 &#x3D; 10    通信行业组件 &#x3D; 11    房产行业组件 &#x3D; 12    西瓜行业组件 &#x3D; 13    轻颜行业组件 &#x3D; 14    醒图行业组件  &#x3D; 15 不传则为全部 (optional)
     * @param page 分页页码 正整数，默认1 (optional, default to 1)
     * @param limit 页大小 正整数且≤50，默认10 (optional, default to 10)
     * @return ApiResponse&lt;StarComponentQueryIndustryAnchorV2Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<StarComponentQueryIndustryAnchorV2Response> openApi2StarComponentQueryIndustryAnchorGetWithHttpInfo(Long starId, Integer anchorStatus, Integer anchorType, Integer page, Integer limit) throws ApiException {
        okhttp3.Call localVarCall = openApi2StarComponentQueryIndustryAnchorGetValidateBeforeCall(starId, anchorStatus, anchorType, page, limit, null);
        Type localVarReturnType = new TypeToken<StarComponentQueryIndustryAnchorV2Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     *  (asynchronously)
     * 
     * @param starId 星图客户ID (required)
     * @param anchorStatus 组件状态 0 &#x3D; 待送审 1 &#x3D; 有效 2 &#x3D;审核中 3 &#x3D; 审核失败 不传则为全部 (optional)
     * @param anchorType 行业锚点类型       电商 &#x3D; 1    汽车 &#x3D; 2    网服 &#x3D; 3    保险 &#x3D; 4    教育 &#x3D; 5    家装 &#x3D; 6    剪映锚点 &#x3D; 7    招商加盟组件 &#x3D; 8    旅游 &#x3D; 9    游戏行业组件 &#x3D; 10    通信行业组件 &#x3D; 11    房产行业组件 &#x3D; 12    西瓜行业组件 &#x3D; 13    轻颜行业组件 &#x3D; 14    醒图行业组件  &#x3D; 15 不传则为全部 (optional)
     * @param page 分页页码 正整数，默认1 (optional, default to 1)
     * @param limit 页大小 正整数且≤50，默认10 (optional, default to 10)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApi2StarComponentQueryIndustryAnchorGetAsync(Long starId, Integer anchorStatus, Integer anchorType, Integer page, Integer limit, final ApiCallback<StarComponentQueryIndustryAnchorV2Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = openApi2StarComponentQueryIndustryAnchorGetValidateBeforeCall(starId, anchorStatus, anchorType, page, limit, _callback);
        Type localVarReturnType = new TypeToken<StarComponentQueryIndustryAnchorV2Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
