/*
 * Oceanengine Open Api
 * 巨量引擎开放平台 Open Api
 *
 * The version of the OpenAPI document: 1.1.19
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.bytedance.ads.api;

import com.bytedance.ads.ApiCallback;
import com.bytedance.ads.ApiClient;
import com.bytedance.ads.ApiException;
import com.bytedance.ads.ApiResponse;
import com.bytedance.ads.Configuration;
import com.bytedance.ads.Pair;

import com.google.gson.reflect.TypeToken;



import com.bytedance.ads.model.SubscribeAccountsListV30Response;
import com.bytedance.ads.model.SubscribeAccountsListV30Statuses;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class SubscribeAccountsListV30Api {
    private ApiClient localVarApiClient;
    private int localHostIndex;
    private String localCustomBaseUrl;

    public SubscribeAccountsListV30Api() {
        this(Configuration.getDefaultApiClient());
    }

    public SubscribeAccountsListV30Api(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public int getHostIndex() {
        return localHostIndex;
    }

    public void setHostIndex(int hostIndex) {
        this.localHostIndex = hostIndex;
    }

    public String getCustomBaseUrl() {
        return localCustomBaseUrl;
    }

    public void setCustomBaseUrl(String customBaseUrl) {
        this.localCustomBaseUrl = customBaseUrl;
    }

    /**
     * Build call for openApiV30SubscribeAccountsListGet
     * @param apPAccessToken  (required)
     * @param appId  (required)
     * @param subscribeTaskId  (required)
     * @param events  (optional)
     * @param coreUserId  (optional)
     * @param advertiserIds  (optional)
     * @param statuses  (optional)
     * @param cursor  (optional)
     * @param count  (optional, default to 100)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApiV30SubscribeAccountsListGetCall(String apPAccessToken, Long appId, Long subscribeTaskId, List<String> events, Long coreUserId, List<Long> advertiserIds, List<SubscribeAccountsListV30Statuses> statuses, Long cursor, Long count, final ApiCallback _callback) throws ApiException {
        String basePath = null;
        // Operation Servers
        String[] localBasePaths = new String[] {  };

        // Determine Base Path to Use
        if (localCustomBaseUrl != null){
            basePath = localCustomBaseUrl;
        } else if ( localBasePaths.length > 0 ) {
            basePath = localBasePaths[localHostIndex];
        } else {
            basePath = null;
        }

        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/open_api/v3.0/subscribe/accounts/list/";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (appId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("app_id", appId));
        }

        if (subscribeTaskId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("subscribe_task_id", subscribeTaskId));
        }

        if (events != null) {
            localVarCollectionQueryParams.addAll(localVarApiClient.parameterToPairs("csv", "events", events));
        }

        if (coreUserId != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("core_user_id", coreUserId));
        }

        if (advertiserIds != null) {
            localVarCollectionQueryParams.addAll(localVarApiClient.parameterToPairs("csv", "advertiser_ids", advertiserIds));
        }

        if (statuses != null) {
            localVarCollectionQueryParams.addAll(localVarApiClient.parameterToPairs("csv", "statuses", statuses));
        }

        if (cursor != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("cursor", cursor));
        }

        if (count != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("count", count));
        }

        if (apPAccessToken != null) {
            localVarHeaderParams.put("APP-Access-Token", localVarApiClient.parameterToString(apPAccessToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        if (localVarContentType != null) {
            localVarHeaderParams.put("Content-Type", localVarContentType);
        }

        String[] localVarAuthNames = new String[] { "ApiKeyAuth" };
        return localVarApiClient.buildCall(basePath, localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call openApiV30SubscribeAccountsListGetValidateBeforeCall(String apPAccessToken, Long appId, Long subscribeTaskId, List<String> events, Long coreUserId, List<Long> advertiserIds, List<SubscribeAccountsListV30Statuses> statuses, Long cursor, Long count, final ApiCallback _callback) throws ApiException {
        // verify the required parameter 'apPAccessToken' is set
        if (apPAccessToken == null) {
            throw new ApiException("Missing the required parameter 'apPAccessToken' when calling openApiV30SubscribeAccountsListGet(Async)");
        }

        // verify the required parameter 'appId' is set
        if (appId == null) {
            throw new ApiException("Missing the required parameter 'appId' when calling openApiV30SubscribeAccountsListGet(Async)");
        }

        // verify the required parameter 'subscribeTaskId' is set
        if (subscribeTaskId == null) {
            throw new ApiException("Missing the required parameter 'subscribeTaskId' when calling openApiV30SubscribeAccountsListGet(Async)");
        }

        return openApiV30SubscribeAccountsListGetCall(apPAccessToken, appId, subscribeTaskId, events, coreUserId, advertiserIds, statuses, cursor, count, _callback);

    }

    /**
     * 
     * 
     * @param apPAccessToken  (required)
     * @param appId  (required)
     * @param subscribeTaskId  (required)
     * @param events  (optional)
     * @param coreUserId  (optional)
     * @param advertiserIds  (optional)
     * @param statuses  (optional)
     * @param cursor  (optional)
     * @param count  (optional, default to 100)
     * @return SubscribeAccountsListV30Response
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public SubscribeAccountsListV30Response openApiV30SubscribeAccountsListGet(String apPAccessToken, Long appId, Long subscribeTaskId, List<String> events, Long coreUserId, List<Long> advertiserIds, List<SubscribeAccountsListV30Statuses> statuses, Long cursor, Long count) throws ApiException {
        ApiResponse<SubscribeAccountsListV30Response> localVarResp = openApiV30SubscribeAccountsListGetWithHttpInfo(apPAccessToken, appId, subscribeTaskId, events, coreUserId, advertiserIds, statuses, cursor, count);
        return localVarResp.getData();
    }

    /**
     * 
     * 
     * @param apPAccessToken  (required)
     * @param appId  (required)
     * @param subscribeTaskId  (required)
     * @param events  (optional)
     * @param coreUserId  (optional)
     * @param advertiserIds  (optional)
     * @param statuses  (optional)
     * @param cursor  (optional)
     * @param count  (optional, default to 100)
     * @return ApiResponse&lt;SubscribeAccountsListV30Response&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SubscribeAccountsListV30Response> openApiV30SubscribeAccountsListGetWithHttpInfo(String apPAccessToken, Long appId, Long subscribeTaskId, List<String> events, Long coreUserId, List<Long> advertiserIds, List<SubscribeAccountsListV30Statuses> statuses, Long cursor, Long count) throws ApiException {
        okhttp3.Call localVarCall = openApiV30SubscribeAccountsListGetValidateBeforeCall(apPAccessToken, appId, subscribeTaskId, events, coreUserId, advertiserIds, statuses, cursor, count, null);
        Type localVarReturnType = new TypeToken<SubscribeAccountsListV30Response>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     *  (asynchronously)
     * 
     * @param apPAccessToken  (required)
     * @param appId  (required)
     * @param subscribeTaskId  (required)
     * @param events  (optional)
     * @param coreUserId  (optional)
     * @param advertiserIds  (optional)
     * @param statuses  (optional)
     * @param cursor  (optional)
     * @param count  (optional, default to 100)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> OK </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call openApiV30SubscribeAccountsListGetAsync(String apPAccessToken, Long appId, Long subscribeTaskId, List<String> events, Long coreUserId, List<Long> advertiserIds, List<SubscribeAccountsListV30Statuses> statuses, Long cursor, Long count, final ApiCallback<SubscribeAccountsListV30Response> _callback) throws ApiException {

        okhttp3.Call localVarCall = openApiV30SubscribeAccountsListGetValidateBeforeCall(apPAccessToken, appId, subscribeTaskId, events, coreUserId, advertiserIds, statuses, cursor, count, _callback);
        Type localVarReturnType = new TypeToken<SubscribeAccountsListV30Response>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
